/**
 * request
 * @description Do request
 * @param {Object} event
 */
function request(event) {

	var client,
	    httpConfig,
	    url,
	    data,
	    credentials,
	    forceBadCredentials;

	forceBadCredentials = true; //Set value to true to force bug on Android
	url = "https://mimaen.webs.upv.es/error401/?platform=" + ((OS_IOS)? "ios":"android");

	credentials = {
		username : (forceBadCredentials) ? "badUser" : "user",
		password : "p$wd"
	};

	//Dummy post param
	data = {
		dummy : 1
	};

	httpConfig = {
		onload : onLoad,
		onerror : onError,
		onreadystatechange : onReadyStateChange,
		timeout : 3000,
		withCredentials : true,
		username : credentials.username,
		password : credentials.password
	};

	client = Ti.Network.createHTTPClient(httpConfig);

	client.open("POST", url);
	client.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	client.send(data);
}

/**
 * onReadyStateChange
 * @description Debug readyState
 * @param {Object} event
 */
function onReadyStateChange(event) {
	Ti.API.info("onReadyStateChange");

	var readyState = this.readyState;

	switch(readyState) {
	case 0:
		// after HTTPClient declared, prior to open()
		// though Ti won't actually report on this readyState
		Ti.API.info('case 0, readyState = ' + readyState);
		break;
	case 1:
		// open() has been called, now is the time to set headers
		Ti.API.info('case 1, readyState = ' + readyState);
		break;
	case 2:
		// headers received, xhr.status should be available now
		Ti.API.info('case 2, readyState = ' + readyState);
		break;
	case 3:
		// data is being received, onsendstream/ondatastream being called now
		Ti.API.info('case 3, readyState = ' + readyState);
		break;
	case 4:
		// done, onload or onerror should be called now
		Ti.API.info('case 4, readyState = ' + readyState);
		Ti.API.info("HTTP DONE WITH STATUS TEXT: " + this.getStatusText());
		break;
	}
}

/**
 * onLoad
 * @description Http Success Callback
 * @param {Object} event
 */
function onLoad(event) {
	Ti.API.info("onLoad");
	var statusCode,
	    statusText,
	    responseText,
	    result;

	statusCode = this.getStatus();
	statusText = this.getStatusText();
	responseText = this.getResponseText();

	result = "onLoad Callback - Status Code: " + statusCode + " - " + "Status Text: " + statusText + " - " + "Response Text: " + responseText;

	Ti.API.info(result);
	$.state.text = result;
}

/**
 * onError
 * @description Http Error callback
 * @param {Object} event
 */
function onError(event) {
	Ti.API.info("onError");

	var statusCode,
	    statusText,
	    result;

	statusCode = this.getStatus();
	statusText = this.getStatusText();

	result = "onError Callback - Status Code: " + statusCode + " - " + "Status Text: " + statusText;

	Ti.API.info(result);
	$.state.text = result;
}

$.index.open();
